#include "jsweb.h"

JSBool test_constructor(JSContext* context, JSObject* object, uintN argc,
                        jsval* argv, jsval* returnValue)
{
    printf("*** constructor for Test: %x\n", object);
    return JS_TRUE;
}

void test_finaliser(JSContext* context, JSObject* object)
{
    printf("*** finaliser for Test: %x\n", object);
}

JSClass test_class = {
    "Test", JSCLASS_GLOBAL_FLAGS | JSCLASS_HAS_PRIVATE,
    JS_PropertyStub,  JS_PropertyStub,
    JS_PropertyStub,  JS_PropertyStub,
    JS_EnumerateStub, JS_ResolveStub,
    JS_ConvertStub,   test_finaliser,
    JSCLASS_NO_OPTIONAL_MEMBERS
};

JSBool test_get_sample(JSContext* context, JSObject* object, jsval id,
                       jsval* rvalue)
{
    //  create a new instance of Test
    JSObject* sample= (JSObject*)JS_GetPrivate(context, object);
    if (sample) {
        *rvalue= OBJECT_TO_JSVAL(sample);
        return JS_TRUE;
    }
    
    sample= JS_ConstructObject(context, &test_class, NULL, NULL);
    JS_SetPrivate(context, object, sample);
    *rvalue= OBJECT_TO_JSVAL(sample);
    return JS_TRUE;
}

JSBool test_get_sample_fn(JSContext* context, JSObject* object, uintN argc,
                          jsval* argv, jsval* rvalue)
{
    //  create a new instance of Test
    JSObject* sample= (JSObject*)JS_GetPrivate(context, object);
    if (sample) {
        *rvalue= OBJECT_TO_JSVAL(sample);
        return JS_TRUE;
    }
    
    sample= JS_ConstructObject(context, &test_class, NULL, NULL);
    JS_SetPrivate(context, object, sample);
    *rvalue= OBJECT_TO_JSVAL(sample);
    return JS_TRUE;
}

static JSPropertySpec test_properties[] = {
    { "sample", 0, JSPROP_PERMANENT, test_get_sample, NULL },
    { NULL, 0, 0, NULL, NULL }
};

/* We use a mix of JS_FS and JS_FN to test both kinds of natives. */
static JSFunctionSpec test_methods[] = {
    JS_FS("get_sample", test_get_sample_fn, 0, 0, 0),
    // JS_FS("print", Print, 0,0,0),
    // JS_FS("version", Version, 0, 0, 0),
    // JS_FS("gc", CollectGarbage, 0, 0, 0),
    JS_FS_END
};


void setupTestClass(JSContext* context, JSObject* scope)
{
    JS_InitClass(context, scope, NULL, &test_class,
                 &test_constructor, /*constructor args*/0,
                 test_properties, test_methods,
                 NULL,  NULL);
}
